/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a194\script\cam_dump.as
 * Generated: 02-Dec-2012 02:17:05
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3be2e0 (0x7be2e0)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc1300 (0x4c1300)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc1330 (0x4c1330)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3be760 (0x7be760)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3beea0 (0x7beea0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3bec30 (0x7bec30)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3beb20 (0x7beb20)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3bef00 (0x7bef00)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3be9f0 (0x7be9f0)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3be710 (0x7be710)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3beed0 (0x7beed0)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3be790 (0x7be790)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3be8c0 (0x7be8c0)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3be330 (0x7be330)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3bde30 (0x7bde30)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x258140 (0x658140)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x256cd0 (0x656cd0)
	void RemoveAll();		// 'Overgrowth.exe' + 0x256c20 (0x656c20)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x256d30 (0x656d30)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x257f50 (0x657f50)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x257fc0 (0x657fc0)
	void Update();		// 'Overgrowth.exe' + 0x25ca10 (0x65ca10)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 position;		// byteOffset: 0x80
	bool controlled;		// byteOffset: 0xac
	bool frozen;		// byteOffset: 0xd0
	vec3 velocity;		// byteOffset: 0xd4
	bool ignore_mouse_input;		// byteOffset: 0xe4
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2b9840 (0x6b9840)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2b97f0 (0x6b97f0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x3843f0 (0x7843f0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x384250 (0x784250)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x3841e0 (0x7841e0)
	float GetLens();		// 'Overgrowth.exe' + 0x384230 (0x784230)
	void Update();		// 'Overgrowth.exe' + 0x384870 (0x784870)
	bool valid();		// 'Overgrowth.exe' + 0x3827b0 (0x7827b0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x17ea3ae8
SphereCollision sphere_col;		// 0x17ea3aec
GUI gui;		// 0x1ae4efb0
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x4402dc (0x8402dc)
CameraObject co;		// 0x1cb1bde0
CameraAnimationReader camera_animation_reader;		// 0x1cb1bec8
