/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a194\script\playercontrol_dump.as
 * Generated: 02-Dec-2012 02:17:05
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// enemycontrol.as
	// aschar.as
	// situationawareness.as
	// interpdirection.as
	// aircontrols.as
	// fliproll.as
	// ledgegrab.as
	// playercontrol.as


/***********************************************
 * Global Functions:
 */

NavPath __cdecl GetPath(vec3, vec3)			// 'Overgrowth.exe' + 0x257310 (0x657310)
vec3 __cdecl NavRaycast(vec3, vec3)			// 'Overgrowth.exe' + 0x256bd0 (0x656bd0)
vec3 __cdecl NavPoint(vec3)			// 'Overgrowth.exe' + 0x256b90 (0x656b90)
void __cdecl SendMessage(int, int, vec3, vec3)			// 'Overgrowth.exe' + 0x257dc0 (0x657dc0)
void __cdecl SendMessage(int, string)			// 'Overgrowth.exe' + 0x258fc0 (0x658fc0)
vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3be2e0 (0x7be2e0)
float __cdecl GetAnimationEventTime( string &in, string &in )			// 'Overgrowth.exe' + 0x39c800 (0x79c800)


/***********************************************
 * Objects:
 */

class Level
{		// size: 0x0, flags:  asOBJ_REF
	int QueryIntFunction(string);		// 'Overgrowth.exe' + 0x3bb010 (0x7bb010)
	int GetNumObjectives();		// 'Overgrowth.exe' + 0x3ba810 (0x7ba810)
	int GetNumAchievements();		// 'Overgrowth.exe' + 0x3ba7e0 (0x7ba7e0)
	const string &GetObjective(int);		// 'Overgrowth.exe' + 0x3bade0 (0x7bade0)
	const string &GetAchievement(int);		// 'Overgrowth.exe' + 0x3bacf0 (0x7bacf0)
	void Execute(string);		// 'Overgrowth.exe' + 0x3ba840 (0x7ba840)
};

class NavPath
{		// size: 0x14, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	bool success;		// byteOffset: 0x10
//-----
	int NumPoints();		// 'Overgrowth.exe' + 0x3bfee0 (0x7bfee0)
	vec3 GetPoint(int);		// 'Overgrowth.exe' + 0x3bff00 (0x7bff00)
};

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc1300 (0x4c1300)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc1330 (0x4c1330)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3be760 (0x7be760)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3beea0 (0x7beea0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3bec30 (0x7bec30)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3beb20 (0x7beb20)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3bef00 (0x7bef00)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3be9f0 (0x7be9f0)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3be710 (0x7be710)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3beed0 (0x7beed0)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3be790 (0x7be790)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3be8c0 (0x7be8c0)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3be330 (0x7be330)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3bde30 (0x7bde30)
};

class CharacterScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3bc3d0 (0x7bc3d0)
	string GetObjPath();		// 'Overgrowth.exe' + 0x3bbfc0 (0x7bbfc0)
	string GetSkeletonPath();		// 'Overgrowth.exe' + 0x3bbf90 (0x7bbf90)
	string GetAnimPath(string);		// 'Overgrowth.exe' + 0x3bc2c0 (0x7bc2c0)
	string GetAttackPath(string);		// 'Overgrowth.exe' + 0x3bc1b0 (0x7bc1b0)
	void GetTeamString(string &out);		// 'Overgrowth.exe' + 0x3bbff0 (0x7bbff0)
	float GetHearing();		// 'Overgrowth.exe' + 0x3bbf50 (0x7bbf50)
};

class ReactionScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3b9d00 (0x7b9d00)
	string GetAnimPath(float);		// 'Overgrowth.exe' + 0x3b9cd0 (0x7b9cd0)
	int GetMirrored();		// 'Overgrowth.exe' + 0x3b9cb0 (0x7b9cb0)
};

class AttackScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x23de80 (0x63de80)
	string GetPath();		// 'Overgrowth.exe' + 0x23d850 (0x63d850)
	string GetSpecial();		// 'Overgrowth.exe' + 0x23dca0 (0x63dca0)
	string GetUnblockedAnimPath();		// 'Overgrowth.exe' + 0x23dd60 (0x63dd60)
	string GetBlockedAnimPath();		// 'Overgrowth.exe' + 0x23dd30 (0x63dd30)
	string GetThrowAnimPath();		// 'Overgrowth.exe' + 0x23dd00 (0x63dd00)
	string GetThrownAnimPath();		// 'Overgrowth.exe' + 0x23dcd0 (0x63dcd0)
	string GetThrownCounterAnimPath();		// 'Overgrowth.exe' + 0x23d880 (0x63d880)
	int IsThrow();		// 'Overgrowth.exe' + 0x23d980 (0x63d980)
	int GetHeight();		// 'Overgrowth.exe' + 0x23dc90 (0x63dc90)
	vec3 GetCutPlane();		// 'Overgrowth.exe' + 0x23d960 (0x63d960)
	int GetCutPlaneType();		// 'Overgrowth.exe' + 0x23d950 (0x63d950)
	bool HasCutPlane();		// 'Overgrowth.exe' + 0x23d940 (0x63d940)
	vec3 GetStabDir();		// 'Overgrowth.exe' + 0x23d920 (0x63d920)
	int GetStabDirType();		// 'Overgrowth.exe' + 0x23d910 (0x63d910)
	bool HasStabDir();		// 'Overgrowth.exe' + 0x23d900 (0x63d900)
	int GetDirection();		// 'Overgrowth.exe' + 0x23dc80 (0x63dc80)
	int GetSwapStance();		// 'Overgrowth.exe' + 0x23dc70 (0x63dc70)
	int GetSwapStanceBlocked();		// 'Overgrowth.exe' + 0x23dc60 (0x63dc60)
	int GetUnblockable();		// 'Overgrowth.exe' + 0x23dc50 (0x63dc50)
	int GetFleshUnblockable();		// 'Overgrowth.exe' + 0x23d8f0 (0x63d8f0)
	int GetAsLayer();		// 'Overgrowth.exe' + 0x23d8e0 (0x63d8e0)
	string GetAlternate();		// 'Overgrowth.exe' + 0x23d8b0 (0x63d8b0)
	string GetReactionPath();		// 'Overgrowth.exe' + 0x23dbc0 (0x63dbc0)
	string GetMaterialEvent();		// 'Overgrowth.exe' + 0x23dc20 (0x63dc20)
	vec3 GetImpactDir();		// 'Overgrowth.exe' + 0x23dd90 (0x63dd90)
	float GetBlockDamage();		// 'Overgrowth.exe' + 0x23db40 (0x63db40)
	float GetSharpDamage();		// 'Overgrowth.exe' + 0x23dac0 (0x63dac0)
	float GetDamage();		// 'Overgrowth.exe' + 0x23da40 (0x63da40)
	float GetForce();		// 'Overgrowth.exe' + 0x23d9c0 (0x63d9c0)
	int GetMirrored();		// 'Overgrowth.exe' + 0x23d840 (0x63d840)
	int GetMobile();		// 'Overgrowth.exe' + 0x23d9b0 (0x63d9b0)
};

class PathScriptReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	int GetNearestPoint(vec3);		// 'Overgrowth.exe' + 0x3ba3f0 (0x7ba3f0)
	vec3 GetPointPosition(int);		// 'Overgrowth.exe' + 0x3ba3d0 (0x7ba3d0)
	int GetConnectedPoint(int);		// 'Overgrowth.exe' + 0x3ba3b0 (0x7ba3b0)
	int GetOtherConnectedPoint(int, int);		// 'Overgrowth.exe' + 0x3ba390 (0x7ba390)
};



/***********************************************
 * Global Properties:
 */

Level level;		// 'Overgrowth.exe' + 0x53d0a0 (0x93d0a0)
int _plant_movement_msg;		// 'Overgrowth.exe' + 0x440488 (0x840488)
int _editor_msg;		// 'Overgrowth.exe' + 0x44048c (0x84048c)
ScriptParams params;		// 0x17d1cd74
ASCollisions col;		// 0x142afc60
SphereCollision sphere_col;		// 0x142afc64
MovementObject this_mo;		// 0x17d1cd00
int _at_grip;		// 'Overgrowth.exe' + 0x4b8400 (0x8b8400)
int _at_sheathe;		// 'Overgrowth.exe' + 0x4b83fc (0x8b83fc)
uint8 _ANM_MIRRORED;		// 'Overgrowth.exe' + 0x4b7d44 (0x8b7d44)
uint8 _ANM_MOBILE;		// 'Overgrowth.exe' + 0x4b7d45 (0x8b7d45)
uint8 _ANM_SUPER_MOBILE;		// 'Overgrowth.exe' + 0x4b7d46 (0x8b7d46)
uint8 _ANM_SWAP;		// 'Overgrowth.exe' + 0x4b7d47 (0x8b7d47)
uint8 _ANM_FROM_START;		// 'Overgrowth.exe' + 0x4b7d48 (0x8b7d48)
CharacterScriptGetter character_getter;		// 0x17d1ce58
ReactionScriptGetter reaction_getter;		// 0x17d1cdec
AttackScriptGetter attack_getter;		// 0x17d1ce10
const int _high; // = 0
const int _medium; // = 1
const int _low; // = 2
const int _right; // = 0
const int _front; // = 1
const int _left; // = 2
AttackScriptGetter attack_getter2;		// 0x17d1ce34
PathScriptReader path_script_reader;		// 0x17d1ce6c
